// This may look like C code, but it is really -*- C++ -*-
// RTSS --- Railway Total System Simulator
// (c) TAKAGI Ryo (at Kogakuin University)
// RS_Object.cc --- functions of classes RS_Object and RS_ObjectCreator
// -----
// ChangeLog:
// 2009. 7. 10
//  File created.
// -----

#include "RS_Object.hh"
#include <cstdlib>
#include <vector>

using std :: cerr ;
using std :: endl ;
using std :: vector ;



// ----
// Static variables.
// ----
double RS_Object :: t_obj = 0.0 ;
double RS_Object :: delta_t = 0.0 ;
double RS_Object :: delta_t_for_cal = 0.0 ;
double RS_Object :: CYCLE_TIME = 0.0 ;
bool RS_Object :: IS_CYCLIC = false ;




/**********************************************************************
 * RS_ObjectContainer :: locate ( const string & key_in )
 * : locates an object.
 *  key_in : key to the object.
 **********************************************************************/
RS_Object const *
RS_ObjectContainer :: locate
( string const & x )
const
{
  map < string , RS_Object * > :: const_iterator ii = this -> find ( x ) ;
  if ( ii == this -> end () )
  {
    return 0 ;
  }
  return ii -> second ;
}

RS_Object *
RS_ObjectContainer :: locate
( string const & x )
{
  map < string , RS_Object * > :: iterator ii = this -> find ( x ) ;
  if ( ii == this -> end () )
  {
    return 0 ;
  }
  return ii -> second ;
}
