// -*- C++ -*-

// ダイクストラ法のデモ

#include "X_PassengerActivity.hh"
#include "X_Station.hh"


X_OD_Data :: X_OD_Data
( TiXmlNode const * const & curnode )
  : X_OD_Data_Base ( curnode ) ,
    _from_str () ,
    _to_str () ,
    _demand ( 0 )
{
  if ( ! curnode )
  {
    cerr << "Error: node not set in X_OD_Data constructor." << endl ;
    exit ( 1 ) ;
  }
  if ( curnode -> ValueStr () != "data" )
  {
    cerr << "Error: <" << curnode -> ValueStr ()
         << "> tag not allowed in X_OD_Data constructor." << endl ;
    exit ( 1 ) ;
  }

  // -----
  // (1) Get all attributes of this "data" tag.
  // -----
  map < string , string > _a_m ;
  getAttributeMap ( curnode , _a_m ) ;
  string _ein_msg = "in initialisation of an X_OD_Data object" ;

  // -----
  // (2) Find attribute "class" in the map.
  // -----
  map < string , string > :: iterator ii = findAttributeInMap
    ( _a_m , "class" , _ein_msg , true ) ;
  _a_m . erase ( ii ) ;

  // -----
  // (3) Find attribute "name" in the map. Required.
  // -----
  ii = findAttributeInMap ( _a_m , "name" , _ein_msg , true ) ;
  _a_m . erase ( ii ) ;

  // -----
  // (4) Find attribute "from" in the map. Required.
  // -----
  ii = findAttributeInMap ( _a_m , "from" , _ein_msg , true ) ;
  _from_str = ii -> second ;
  _a_m . erase ( ii ) ;

  // -----
  // (5) Find attribute "to" in the map. Required.
  // -----
  ii = findAttributeInMap ( _a_m , "to" , _ein_msg , true ) ;
  _to_str = ii -> second ;
  _a_m . erase ( ii ) ;

  // -----
  // (6) Find attribute "demand" in the map. Required.
  // -----
  ii = findAttributeInMap ( _a_m , "demand" , _ein_msg , true ) ;
  sscanf ( ii -> second . c_str () , "%lf" , & _demand ) ;
  _a_m . erase ( ii ) ;

  // -----
  // (7) Check if attribute map is exhausted.
  // -----
  if ( _a_m . size () )
  {
    ii = _a_m . begin () ;
    cerr << "Error: " << _ein_msg << ": incorrect attribute \""
         << ii -> first << "\" found when initialising an "
         << "intratime instance" << endl ;
    exit ( 1 ) ;
  }
}




bool
X_OD_Data_Container :: create
( TiXmlNode const * & _n_in ,
  vector < string > const & _s_in ,
  vector < RS_Object * > const & _o_in )
{
  string xxx = getClassString ( _n_in ) ;
  string yyy = getNameString ( _n_in ) ;
  X_OD_Data_Base * x = ODD_Expander :: create ( xxx , _n_in ) ;
  ( * this ) [ yyy ] = x ;
  vector < string > :: const_iterator ii = _s_in . begin () ;
  vector < RS_Object * > :: const_iterator jj = _o_in . begin () ;
  while ( ii != _s_in . end () && jj != _o_in . end () )
  {
    if ( ! x -> acceptInitObject ( * ii , * jj ) )
    {
      cerr << "Error: <using> tag not properly interpreted..." << endl ;
      exit ( 1 ) ;
    }
    ++ ii ;
    ++ jj ;
  }
  return true ;
}
