// -*- C++ -*-

// ダイクストラ法のデモ

#include <algorithm>
#include "X_PassengerActivity.hh"
#include "X_Station.hh"
#include "X_Train.hh"
#include "X_TrainSet.hh"
#include "X_ScheduleSet.hh"
#include "X_Weight.hh"


using std :: find ;
using std :: sort ;



X_PasApp_F1_Constant_Rate :: X_PasApp_F1_Constant_Rate
( string const & _n_in )
  : X_PassengerAppearance_Base ( _n_in ) ,
    _odc ()
{
}



X_PasApp_F1_Constant_Rate :: X_PasApp_F1_Constant_Rate
( TiXmlNode const * const & curnode )
  : X_PassengerAppearance_Base ( curnode ) ,
    _odc ()
{
  if ( ! curnode )
  {
    cerr << "Error: node not set in X_PasApp_F1_Constant_Rate constructor."
         << endl ;
    exit ( 1 ) ;
  }
  if ( curnode -> ValueStr () != "data" )
  {
    cerr << "Error: <" << curnode -> ValueStr () << "> tag not allowed in "
         << "X_PasApp_F1_Constant_Rate constructor." << endl ;
    exit ( 1 ) ;
  }

  // -----
  // (1) Get all attributes of this "data" tag.
  // -----
  map < string , string > _a_m ;
  getAttributeMap ( curnode , _a_m ) ;
  string _ein_msg
    = "in initialisation of an X_PasApp_F1_Constant_Rate instance" ;

  // -----
  // (2) Find attribute "class" in the map. Required (already checked ---
  // just discard it here).
  // -----
  map < string , string > :: iterator ii = findAttributeInMap
    ( _a_m , "class" , _ein_msg , true ) ;
  _a_m . erase ( ii ) ;

  // -----
  // (3) Find attribute "name" in the map. Required.
  // -----
  ii = findAttributeInMap ( _a_m , "name" , _ein_msg , true ) ;
  setName ( ii -> second ) ;
  _a_m . erase ( ii ) ;

  // -----
  // (4) Check if attribute map is exhausted.
  // -----
  if ( _a_m . size () )
  {
    ii = _a_m . begin () ;
    cerr << "Error: " << _ein_msg << ": incorrect attribute \""
         << ii -> first << "\" found" << endl ;
    exit ( 1 ) ;
  }

  // -----
  // (5) Reading subelements.
  // -----
  for ( TiXmlNode const * _c_in = curnode -> FirstChild () ;
        _c_in ; _c_in = _c_in -> NextSibling () )
  {
    // -----
    // (5-1) Ignore non-Element node.
    // -----
    if ( _c_in -> Type () != TiXmlNode :: TINYXML_ELEMENT )
    {
      continue ;
    }

    // ----
    // (5-2) If _c_in is not of tag <od_data>, abort.
    // ----
    string _v_cin = _c_in -> ValueStr () ;
    if ( _v_cin != "od_data" )
    {
      cerr << "Error: tag \"" << _v_cin << "\" not allowed for setting "
           << "OD data within an X_PasApp_F1_Constant_Rate object"
           << endl ;
      exit ( 1 ) ;
    }

    // ----
    // (5-3) Get all attributes of this "od_data" tag.
    // -----
    map < string , string > _odm ;
    getAttributeMap ( _c_in , _odm ) ;
    string _eod_msg
      = "in reading OD data for X_PasApp_F1_Constant_Rate instance: " ;
    _eod_msg += getName () ;

    // -----
    // (5-4) Find attribute "class" in the map. Required.
    // -----
    map < string , string > :: iterator jj = findAttributeInMap
      ( _odm , "class" , _eod_msg , true ) ;
    string _od_class = jj -> second ;
    _odm . erase ( jj ) ;

    // -----
    // (5-5) Find attribute "from" in the map. Required.
    // -----
    jj = findAttributeInMap ( _odm , "from" , _eod_msg , true ) ;
    string _od_from = jj -> second ;
    _odm . erase ( jj ) ;

    // -----
    // (5-6) Find attribute "to" in the map. Required.
    // -----
    jj = findAttributeInMap ( _odm , "to" , _eod_msg , true ) ;
    string _od_to = jj -> second ;
    _odm . erase ( jj ) ;

    // -----
    // (5-7) Find attribute "demand" in the map. Required.
    // -----
    jj = findAttributeInMap ( _odm , "demand" , _eod_msg , true ) ;
    string _od_demand = jj -> second ;
    _odm . erase ( jj ) ;

    // -----
    // (5-8) Check if attribute map is exhausted.
    // -----
    if ( _odm . size () )
    {
      jj = _odm . begin () ;
      cerr << "Error: " << _eod_msg << ": incorrect attribute \""
           << jj -> first << "\" found" << endl ;
      exit ( 1 ) ;
    }

    // -----
    // (5-9) If no container is found, create it.
    // -----
    map < string , X_OD_Data_Container * > :: iterator
      kk = _odc . find ( _od_from ) ;
    if ( kk == _odc . end () )
    {
      _odc [ _od_from ] = new X_OD_Data_Container ;
      kk = _odc . find ( _od_from ) ;
    }

    // -----
    // (5-10) Create an OD data entry.
    // -----
    vector < string > _x_a ;
    _x_a . clear () ;
    vector < RS_Object * > _x_b ;
    _x_b . clear () ;
    TiXmlElement * _data_elem = new TiXmlElement ( "data" ) ;
    _data_elem -> SetAttribute ( "class" , _od_class ) ;
    _data_elem -> SetAttribute ( "name" , _od_to ) ;
    _data_elem -> SetAttribute ( "from" , _od_from ) ;
    _data_elem -> SetAttribute ( "to" , _od_to ) ;
    _data_elem -> SetAttribute ( "demand" , _od_demand ) ;
    TiXmlNode const * _n_data_elem = _data_elem ;
    kk -> second -> create ( _n_data_elem , _x_a , _x_b ) ;
    delete _data_elem ;
  }
}



RS_ObjectContainer *
X_PasApp_F1_Constant_Rate :: getContainer
( string const & x )
{
  cerr << "Error: No class \"" << x << "\" container found in "
       << "X_PasApp_F1_Constant_Rate" << endl ;
  exit ( 1 ) ;
  return 0 ;
}




RS_ObjectContainer const *
X_PasApp_F1_Constant_Rate :: getContainer
( string const & x )
  const
{
  cerr << "Error: No class \"" << x << "\" container found in "
       << "X_PasApp_F1_Constant_Rate" << endl ;
  exit ( 1 ) ;
  return 0 ;
}




bool
X_PassengerAppearance_Container :: create
( TiXmlNode const * & _n_in ,
  vector < string > const & _s_in ,
  vector < RS_Object * > const & _o_in )
{
  if ( begin () != end () )
  {
    cerr << "Error: this PassengerAppearance container already has an instance "
         << "of name \"" << begin () -> first << "\"" << endl ;
    exit ( 1 ) ;
  }
  string xxx = getClassString ( _n_in ) ;
  string yyy = getNameString ( _n_in ) ;
  X_PassengerAppearance_Base * x = PApp_Expander :: create ( xxx , _n_in ) ;
  ( * this ) [ yyy ] = x ;
  vector < string > :: const_iterator ii = _s_in . begin () ;
  vector < RS_Object * > :: const_iterator jj = _o_in . begin () ;
  while ( ii < _s_in . end () || jj < _o_in . end () )
  {
    if ( x -> acceptInitObject ( * ii , * jj ) )
    {
      ++ ii ;
      ++ jj ;
    }
    else
    {
      cerr << "Error: acceptInitObject failed, type = "
           << * ii << endl ;
      exit ( 1 ) ;
    }
  }
  return true ;
}




// -----
// Locate a depot (const).
// -----
X_PassengerAppearance_Base const *
X_PassengerAppearance_Container :: locatePassengerAppearance
( string const & x )
  const
{
  RS_Object const * retv = locate ( x ) ;
  return dynamic_cast < X_PassengerAppearance_Base const * > ( retv ) ;
}




// -----
// Locate a depot (non-const).
// -----
X_PassengerAppearance_Base *
X_PassengerAppearance_Container :: locatePassengerAppearance
( string const & x )
{
  RS_Object * retv = locate ( x ) ;
  return dynamic_cast < X_PassengerAppearance_Base * > ( retv ) ;
}



// -----
// Get OD data
// -----
X_OD_Data_Base *
X_PasApp_F1_Constant_Rate :: getOD
( X_Station_Base const * _pf ,
  X_Station_Base const * _pt )
{
  map < string , X_OD_Data_Container * > :: iterator
    ii = _odc . find ( _pf -> getName () ) ;
  if ( ii == _odc . end () )
  {
    return 0 ;
  }
  X_OD_Data_Container :: iterator
    jj = ii -> second -> find ( _pt -> getName () ) ;
  if ( jj == ii -> second -> end () )
  {
    return 0 ;
  }
  else
  {
    X_OD_Data_Base *
      _retv = dynamic_cast < X_OD_Data_Base * > ( jj -> second ) ;
    if ( _retv )
    {
      cerr << "Error: in getting OD data from Passenger Appearance object "
           << getName () << ": data incorrectly set" << endl ;
      exit ( 1 ) ;
    }
    return _retv ;
  }
}



// -----
// Get OD data
// -----
X_OD_Data_Base const *
X_PasApp_F1_Constant_Rate :: getOD
( X_Station_Base const * _pf ,
  X_Station_Base const * _pt )
  const
{
  map < string , X_OD_Data_Container * > :: const_iterator
    ii = _odc . find ( _pf -> getName () ) ;
  if ( ii == _odc . end () )
  {
    return 0 ;
  }
  X_OD_Data_Container :: const_iterator
    jj = ii -> second -> find ( _pt -> getName () ) ;
  if ( jj == ii -> second -> end () )
  {
    return 0 ;
  }
  else
  {
    X_OD_Data_Base const *
      _retv = dynamic_cast < X_OD_Data_Base * > ( jj -> second ) ;
    if ( _retv )
    {
      cerr << "Error: in getting OD data from Passenger Appearance object "
           << getName () << ": data incorrectly set" << endl ;
      exit ( 1 ) ;
    }
    return _retv ;
  }
}




// ----
// Returns true if there is at least one OD pair with demand
// ----
bool
X_PasApp_F1_Constant_Rate :: hasOD
( X_Station_Base const * _s )
  const
{
  if ( ! _s )
  {
    cerr << "Error: null pointer to X_PasApp_F1_CR::hasOD()" << endl ;
    exit ( 1 ) ;
  }
  map < string , X_OD_Data_Container * > :: const_iterator
    ii = _odc . find ( _s -> getName () ) ;
  if ( ii == _odc . end () )
  {
    return false ;
  }
  for ( X_OD_Data_Container :: const_iterator jj
          = ii -> second -> begin () ; jj != ii -> second -> end () ; ++ jj )
  {
    X_OD_Data_Base const * x
      = dynamic_cast < X_OD_Data_Base const * > ( jj -> second ) ;
    if ( ! x )
    {
      cerr << "Error: X_OD_Data_Base conversion failed" << endl ;
      exit ( 1 ) ;
    }
    if ( x -> getDemand () > 0 )
    {
      return true ;
    }
  }
  return false ;
}



// ----
// Populate "Emerging Passengers" vector in PlatformBranch
// ----
void
X_PasApp_F1_Constant_Rate :: solveOriginal
( X_PlatformBranch * p_pb ,
  X_Station_Container * xs_c ,
  X_ScheduleSet_Base * p_xs )
{
  // ----
  // Cyclic simulation only
  // ----
  if ( ! RS_Object :: IS_CYCLIC )
  {
    cerr << "Error: X_PasApp_F1_Constant_Rate could not be used if IS_CYCLIC"
         << " is true" << endl ;
    exit ( 1 ) ;
  }

  // ----
  // Originating station.
  // ----
  X_Station_Base const * p_sb_orig
    = p_pb -> getStartSTN () -> getPlatform () -> MyStation () ;
  if ( ! p_sb_orig )
  {
    cerr << "Error: in X_PasApp_F1_Constant_Rate::populatePassTok(): "
         << "could not find originating station pointer" << endl ;
    exit ( 1 ) ;
  }

  // ----
  // Get OD data set (_xxx) for this originating station.
  // ----
  map < string , X_OD_Data_Container * > :: const_iterator
    ii = _odc . find ( p_sb_orig -> getName () ) ;
  if ( ii == _odc . end () )
  {
    return ;
  }
  EmergingPassengers _xxx ;
  _xxx . clear () ;

  // ----
  // Get timings information from the starting PlatformBranch p_pb.
  // ----
  X_SpaceTimeNode const * p_stns = p_pb -> getStartSTN () ;
  X_SpaceTimeNode const * p_stne = p_pb -> getEndSTN () ;
  double _txxx = p_stne -> getTime () - p_stns -> getTime () ;
  int _ixxx = p_stns -> getCycleDelay () ;
  if ( _txxx < 0 )
  {
    _txxx += RS_Object :: CYCLE_TIME ;
  }
  double _txxp = _txxx ;
  _txxx /= 2 ;
  _txxx += p_stns -> getTime () ;
  if ( _txxx >= CYCLE_TIME )
  {
    _txxx -= CYCLE_TIME ;
    ++ _ixxx ;
  }

  // ----
  // Node from which passenger originates.
  // ----
  X_SpaceTimeNode * _pasorig = new X_SpaceTimeNode
    ( DEP , _txxx , 0 , false ) ;
  string _strorig = "PassengerOrigNode-" ;
  _strorig += p_stns -> getName () ;
  _strorig += "--" ;
  _strorig += p_stne -> getName () ;
  _pasorig -> setPlatform ( p_stns -> getPlatform () ) ;
  _pasorig -> RS_Object :: setName ( _strorig ) ;

  for ( X_OD_Data_Container :: const_iterator jj = ii -> second -> begin () ;
        jj != ii -> second -> end () ; ++ jj )
  {
    X_OD_Data_Base const * x
      = dynamic_cast < X_OD_Data_Base const * > ( jj -> second ) ;
    if ( ! x )
    {
      cerr << "Error: X_OD_Data_Base conversion failed" << endl ;
      exit ( 1 ) ;
    }
    X_Station_Base * p_sb_dest = xs_c -> locateStation ( jj -> first ) ;
    X_Passenger_Token * ptok = new X_Passenger_Token
      ( p_sb_orig , p_sb_dest , p_pb , this , _txxx , _ixxx , _txxp ) ;
    cerr << "Passenger token: " << p_sb_orig -> getName () << " -- "
         << p_sb_dest -> getName () << " [" << _txxx << "/" << _ixxx << "]"
         << endl ;
    if ( _xxx . find ( p_sb_dest ) == _xxx . end () )
    {
      _xxx [ p_sb_dest ] = EmergingPassengerSet () ;
    }
    _xxx [ p_sb_dest ] . insert ( ptok ) ;
  }
  p_pb -> setEmergingPassengers ( this , _xxx ) ;

  // ----
  // Set network and simulate.
  // ----
  RS_Dijkstra_MPS < Sujic_Weight , X_Dijkstra_Key > *
    _x_slv = new RS_Dijkstra_MPS < Sujic_Weight , X_Dijkstra_Key >
    ( Sujic_Weight ( LARGENUM , 0 , 0 , 0 ) ) ;
  _dk_solvers [ p_pb ] = _x_slv ;

  for ( X_Station_Container :: iterator ii = xs_c -> begin () ;
        ii != xs_c -> end () ; ++ ii )
  {
    X_Station_Base *
      p_ii = dynamic_cast < X_Station_Base * > ( ii -> second ) ;
    if ( ! p_ii )
    {
      cerr << "Error: in solveOriginal: failed to extract X_Station_Base"
           << endl ;
      exit ( 1 ) ;
    }

    // ----
    // Entrance and exit nodes
    // ----
    X_SpaceTimeNode const * _entr = p_ii -> EntranceNode () ;
    _x_slv -> setNode ( X_Dijkstra_Key ( _entr , 0 ) , _entr -> getName () ) ;
    X_SpaceTimeNode const * _exit = p_ii -> ExitNode () ;
    _x_slv -> setNode ( X_Dijkstra_Key ( _exit , 0 ) , _exit -> getName () ) ;

    // ----
    // Normal platform nodes
    // ----
    for ( X_Platform_Container :: iterator jj = p_ii -> firstPlatform () ;
          jj != p_ii -> lastPlatform () ; ++ jj )
    {
      X_Platform_Base *
        p_jj = dynamic_cast < X_Platform_Base * > ( jj -> second ) ;

      for ( vector < X_SpaceTimeNode * > :: const_iterator ix
              = p_jj -> firstNode () ;
            ix != p_jj -> lastNode () ; ++ ix )
      {
        _x_slv -> setNode
          ( X_Dijkstra_Key ( * ix , 0 ) , ( * ix ) -> getName () ) ;
      }
    }
  }

  // ----
  // Node representing passengers' arrival at the originating platform.
  // ----
  _x_slv -> setNode ( X_Dijkstra_Key ( _pasorig , 0 ) , _strorig ) ;

  // ----
  // Trains must have their own nodes at stations. Note that there may be
  // multiple trainsets, in which case multiple Dijkstra_Key objects must
  // be given.
  // ----
  for ( X_Train_Container :: iterator ii = p_xs -> firstTrain () ;
        ii != p_xs -> lastTrain () ; ++ ii )
  {
    X_Train_Base const *
      _trn = dynamic_cast < X_Train_Base const * > ( ii -> second ) ;
    if ( ! _trn )
    {
      cerr << "Error: dynamic cast to X_Train failed" << endl ;
      exit ( 102 ) ;
    }
    
    // ----
    // First train node
    // ----
    vector < X_SpaceTimeNode * > :: const_iterator ix = _trn -> firstNode () ;
    vector < X_TrainSet_Base const * > const *
      p_vxts = p_xs -> getTrainSets ( * ix , * ( ix + 1 ) ) ;
    for ( vector < X_TrainSet_Base const * > :: const_iterator jx
            = p_vxts -> begin () ; jx != p_vxts -> end () ; ++ jx )
    {
      X_Dijkstra_Key xt = X_Dijkstra_Key ( ( * ix ) , ( * jx ) ) ;
      _x_slv -> setNode ( xt , xt . getName () ) ;
    }
    
    // ----
    // Subsequent train nodes
    // ----
    vector < X_TrainSet_Base const * > const * p_vxts_orig = p_vxts ;
    for ( ++ ix ; ix != _trn -> lastNode () ; ++ ix )
    {
      p_vxts_orig = p_vxts ;
      p_vxts = p_xs -> getTrainSets ( * ( ix - 1 ) , * ix ) ;
      for ( vector < X_TrainSet_Base const * > :: const_iterator
              jx = p_vxts -> begin () ; jx != p_vxts -> end () ; ++ jx )
      {
        // ----
        // Destination nodes
        // ----
        X_Dijkstra_Key xt = X_Dijkstra_Key ( ( * ix ) , ( * jx ) ) ;
        _x_slv -> setNode ( xt , xt . getName () ) ;

        // ----
        // Source nodes, in case it has not been created
        // ----
        vector < X_TrainSet_Base const * > :: const_iterator jy
          = find ( p_vxts_orig -> begin () , p_vxts_orig -> end () , * jx ) ;
        if ( jy == p_vxts_orig -> end () )
        {
          xt = X_Dijkstra_Key ( ( * ( ix - 1 ) ) , ( * jx ) ) ;
          _x_slv -> setNode ( xt , xt . getName () ) ;
        }
      }
    }
  }

  // ----
  // Creating branches at stations.
  // Note::: at stations, branch time length does not need consideration
  // of cycle delays.
  // ----
  for ( map < X_STB_Key , X_PlatformBranch * > :: iterator
          ii = p_xs -> firstPlatformBranch () ;
        ii != p_xs -> lastPlatformBranch () ; ++ ii )
  {
    X_PlatformBranch * p_pb_x = ii -> second ;
    if ( p_pb_x != p_pb )
    {
      // ----
      // Normal platform branch.
      // ----
      _x_slv -> setBranch ( X_Dijkstra_Key ( p_pb_x -> getStartSTN () , 0 ) ,
                            X_Dijkstra_Key ( p_pb_x -> getEndSTN () , 0 ) ,
                            getSujicWeight
                            ( * ( p_pb_x -> getStartSTN () ) ,
                              * ( p_pb_x -> getEndSTN () ) ,
                              false , false , false ) , p_pb_x ) ;
    }
    else
    {
      // ----
      // Platform branch on which passenger token(s) reside. Use two
      // branches.
      // ----
      _x_slv -> setBranch
        ( X_Dijkstra_Key ( p_pb_x -> getStartSTN () , 0 ) ,
          X_Dijkstra_Key ( _pasorig , 0 ) ,
          getSujicWeight ( * ( p_pb_x -> getStartSTN () ) , * _pasorig ,
                           false , false , false ) , p_pb_x ) ;
      _x_slv -> setBranch
        ( X_Dijkstra_Key ( _pasorig , 0 ) ,
          X_Dijkstra_Key ( p_pb_x -> getEndSTN () , 0 ) ,
          getSujicWeight ( * _pasorig , * ( p_pb_x -> getEndSTN () ) ,
                           false , false , false ) , p_pb_x ) ;
    }
  }

  for ( map < X_STB_Key , X_Branch_Base * > :: iterator
          ii = p_xs -> firstTransferBranch () ;
        ii != p_xs -> lastTransferBranch () ; ++ ii )
  {
    X_Branch_Base * p_pb_x = ii -> second ;
    if ( p_pb_x -> getStartSTN () -> isTrain () )
    {
      set < X_TrainSet_Base const * > const * _trs_set
        = p_xs -> getTrainSetsForNode ( p_pb_x -> getStartSTN () ) ;
      if ( _trs_set )
      {
        for ( set < X_TrainSet_Base const * > :: const_iterator
                ii = _trs_set -> begin () ; ii != _trs_set -> end () ; ++ ii )
        {
          cerr << "TS " << ( * ii ) -> getName () << " " ;
          _x_slv -> setBranch
            ( X_Dijkstra_Key ( p_pb_x -> getStartSTN () , * ii ) ,
              X_Dijkstra_Key ( p_pb_x -> getEndSTN () , 0 ) ,
              getSujicWeight ( * ( p_pb_x -> getStartSTN () ) ,
                               * ( p_pb_x -> getEndSTN () ) ,
                               false , false , true ) , p_pb_x ) ;
        }
      }
    }
    else if ( p_pb_x -> getEndSTN () -> isTrain () )
    {
      set < X_TrainSet_Base const * > const * _trs_set
        = p_xs -> getTrainSetsForNode ( p_pb_x -> getEndSTN () ) ;
      if ( _trs_set )
      {
        for ( set < X_TrainSet_Base const * > :: const_iterator
                ii = _trs_set -> begin () ; ii != _trs_set -> end () ; ++ ii )
        {
          cerr << "TS " << ( * ii ) -> getName () << " " ;
          _x_slv -> setBranch
            ( X_Dijkstra_Key ( p_pb_x -> getStartSTN () , 0 ) ,
              X_Dijkstra_Key ( p_pb_x -> getEndSTN () , * ii ) ,
              getSujicWeight ( * ( p_pb_x -> getStartSTN () ) ,
                               * ( p_pb_x -> getEndSTN () ) ,
                               false , false , true ) , p_pb_x ) ;
        }
      }
    }
    else
    {
      cerr << "Error: no transfer branch " << p_pb_x -> getName ()
           << " found in the list of transfer branches" << endl ;
      exit ( 1 ) ;
    }
  }

  for ( map < X_STB_Key , X_Branch_Base * > :: iterator
          ii = p_xs -> firstMiscBranch () ;
        ii != p_xs -> lastMiscBranch () ; ++ ii )
  {
    X_Branch_Base * p_iswb = ii -> second ;
    _x_slv -> setBranch ( X_Dijkstra_Key ( p_iswb -> getStartSTN () , 0 ) ,
                          X_Dijkstra_Key ( p_iswb -> getEndSTN () , 0 ) ,
                          getSujicWeight ( * ( p_iswb -> getStartSTN () ) ,
                                           * ( p_iswb -> getEndSTN () ) ,
                                           true , false , false ) , p_iswb ) ;
  }

  // ----
  // Creating train branches.
  // ----
  for ( map < X_STB_Key , map
          < X_TrainSet_Base const * , X_TrainBranch * > > :: iterator
          ii = p_xs -> firstTrainBranches () ;
        ii != p_xs -> lastTrainBranches () ; ++ ii )
  {
    for ( map < X_TrainSet_Base const * , X_TrainBranch * > :: iterator
            jj = ii -> second . begin () ;
          jj != ii -> second . end () ; ++ jj )
    {
      cerr << "TS " << jj -> first -> getName () << " " ;
      _x_slv -> setBranch
        ( X_Dijkstra_Key ( jj -> second -> getStartSTN () , jj -> first ) ,
          X_Dijkstra_Key ( jj -> second -> getEndSTN () , jj -> first ) ,
          getSujicWeight ( * ( jj -> second -> getStartSTN () ) ,
                           * ( jj -> second -> getEndSTN () ) ,
                           true , true , false ) , jj -> second ) ;
    }
  }

  cerr << endl << "Solver complete: " << p_pb -> getName () << endl << endl ;

  // ----
  // Solver complete. Run the algorithm.
  // ----
  _x_slv -> run ( X_Dijkstra_Key ( _pasorig , 0 ) ,
                  Sujic_Weight ( 0 , 0 , 0 , 0 ) ) ;

  // ----
  // Printing paths.
  // ----
  for ( X_Station_Container :: iterator ii = xs_c -> begin () ;
        ii != xs_c -> end () ; ++ ii )
  {
    X_Station_Base *
      p_ii = dynamic_cast < X_Station_Base * > ( ii -> second ) ;
    _x_slv -> printRoute ( X_Dijkstra_Key ( p_ii -> ExitNode () , 0 ) ) ;
    vector < vector < RS_Object * > >
      blist = _x_slv -> getRoutesByAccompanyingObjects
      ( X_Dijkstra_Key ( p_ii -> ExitNode () , 0 ) ) ;
    if ( blist . size () )
    {
      dividing . clear () ;
      dividing . push_back ( 1.0 ) ;
      for ( unsigned int i = 1 ; i < blist . size () ; ++ i )
      {
        dividing . push_back ( 0 ) ;
      }
      sort ( blist . begin () , blist . end () , LessROV () ) ;
      EmergingPassengerSet const * _eps
        = p_pb -> getEmergingPassengers ( this , p_ii ) ;
      cerr << "BLIST SIZE: " << blist . size () << endl ;
      processRouteDiversion
        ( blist . begin () , 0 , blist . end () , blist . size () , 0 ) ;
      unsigned int i = 0 ;
      for ( vector < vector < RS_Object * > > :: iterator ij
              = blist . begin () ; ij != blist . end () ; ++ ij , ++ i )
      {
        cerr << " " << i << "(" << dividing [ i ] << "): " ;
        for ( vector < RS_Object * > :: iterator jj = ij -> begin () ;
              jj != ij -> end () ; ++ jj )
        {
          X_Branch_Base * p_jj = dynamic_cast < X_Branch_Base * > ( * jj ) ;
          if ( ! p_jj )
          {
            cerr << endl << "Error: oops, branch could not be extracted!"
                 << endl ;
            exit ( 1 ) ;
          }
          cerr << " --> " << p_jj -> getName () ;
          if ( _eps )
          {
            for ( EmergingPassengerSet :: const_iterator kk
                    = _eps -> begin () ; kk != _eps -> end () ; ++ kk )
            {
              if ( p_jj != p_pb )
              {
                p_jj -> addPassenger ( * kk , dividing [ i ] ) ;
              }
            }
          }
        }
        cerr << " --> " << p_ii -> ExitNode () -> getName () << endl ;
      }
    }
    else
    {
      cerr << _strorig << ": unreachable to "
           << p_ii -> ExitNode () -> getName () << endl ;
    }
  }
}



// ----
// Subfunction of solveOriginal.
// ----
void
X_PasApp_F1_Constant_Rate :: processRouteDiversion
( vector < vector < RS_Object * > > :: iterator ib ,
  vector < vector < RS_Object * > > :: size_type sb ,
  vector < vector < RS_Object * > > :: iterator ie ,
  vector < vector < RS_Object * > > :: size_type se ,
  vector < RS_Object * > :: size_type siz_s /* = 0 */ )
{
  ROV_Same_Until same_until ;
  vector < RS_Object * > :: size_type sizm = ib -> size () ;
  vector < RS_Object * > :: size_type sizx = siz_s ;
  vector < vector < RS_Object * > > :: iterator iz = ie ;
  vector < vector < RS_Object * > > :: size_type sy = sb + 1 ;
  vector < vector < RS_Object * > > :: size_type sz = se ;
  for ( vector < vector < RS_Object * > > :: iterator iy = ib + 1 ;
        iy < ie ; ++ iy , ++ sy )
  {
    sizx = same_until ( * ib , * iy , siz_s ) ;
    if ( sizm > sizx )
    {
      sizm = sizx ;
      iz = iy ;
      sz = sy ;
    }
  }
  if ( sz < se )
  {
    cerr << "::::" << sb << "(m" << ib -> size () << ") and " << sz << "(m"
         << iz -> size () << ") diverges at " << sizm << endl ;
    double div_a = dividing [ sb ] ;
    X_Branch_Base const * _bb
      = dynamic_cast < X_Branch_Base const * > ( ( * ib ) [ sizm ] ) ;
    X_Branch_Base const * _bz
      = dynamic_cast < X_Branch_Base const * > ( ( * iz ) [ sizm ] ) ;
    if ( _bb -> MyTrain () && _bb -> MyTrainSet ()
         && _bz -> MyTrain () && _bz -> MyTrainSet ()
         && _bb -> MyTrain () == _bz -> MyTrain ()
         && _bb -> MyTrainSet () != _bz -> MyTrainSet () )
    {
      // ----
      // Transfer node
      // ----
      double cap_b = _bb -> MyTrainSet () -> Type () -> Capacity () ;
      double cap_z = _bz -> MyTrainSet () -> Type () -> Capacity () ;
      double div_b = div_a * cap_b / ( cap_b + cap_z ) ;
      double div_z = div_a - div_b ;
      cerr << "  division = " << div_b << " : " << div_z << endl ;
      dividing [ sb ] = div_b ;
      dividing [ sz ] = div_z ;
    }
    else
    {
      cerr << "  division = " << div_a / 2 << " : " << div_a / 2 << endl ;
      dividing [ sb ] = div_a / 2 ;
      dividing [ sz ] = div_a / 2 ;
    }
  }
  if ( sz - sb > 1 )
  {
    processRouteDiversion ( ib , sb , iz , sz , sizm ) ;
  }
  if ( se - sz > 1 )
  {
    processRouteDiversion ( iz , sz , ie , se , sizm ) ;
  }
}
