// -*- C++ -*-

// _CNXg@̃f

#include "Expandable.hh"
#include "RS_XmlReader.hh"
#include "X_ScheduleSet.hh"



// -----
// Create an object.
// -----
bool
X_ScheduleSet_Container :: create
( TiXmlNode const * & _n_in ,
  vector < string > const & _s_in ,
  vector < RS_Object * > const & _o_in )
{
  string xxx = getClassString ( _n_in ) ;
  string yyy = getNameString ( _n_in ) ;
  if ( find ( yyy ) != end () )
  {
    cerr << "Error: ScheduleSet container already has a ScheduleSet instance "
         << "of name \"" << xxx << "\"" << endl ;
    exit ( 1 ) ;
  }
  X_ScheduleSet_Base * x = SchS_Expander :: create ( xxx , _n_in ) ;
  if ( ( ! _first ) )
  {
    _first = x ;
    RS_Object :: IS_CYCLIC = x -> isCyclic () ;
    RS_Object :: CYCLE_TIME = x -> CycleTime () ;
  }
  else
  {
    if ( x -> isCyclic () )
    {
      cerr << "Error: attribute cycletime set in the initialisation data of "
           << "schedule set \"" << x -> getName () << "\", which is not the "
           << "first set" << endl ;
      exit ( 1 ) ;
    }
    x -> setCyclicVars () ;
    X_ScheduleSet_Base * y = _first ;
    while ( y -> Superseding () )
    {
      y = y -> Superseding () ;
    }
    y -> setSuperseding ( x ) ;
    x -> setOriginal ( y ) ;
  }
  ( * this ) [ yyy ] = x ;
  vector < string > :: const_iterator ii = _s_in . begin () ;
  vector < RS_Object * > :: const_iterator jj = _o_in . begin () ;
  while ( ii < _s_in . end () || jj < _o_in . end () )
  {
    if ( x -> acceptInitObject ( * ii , * jj ) )
    {
      ++ ii ;
      ++ jj ;
    }
    else
    {
      cerr << "Error: acceptInitObject failed, type = "
           << * ii << endl ;
      exit ( 1 ) ;
    }
  }
  return true ;
}
