// -*- C++ -*-

// ダイクストラ法のデモ

#include "X_SpaceTimeNode.hh"
#include "X_Station.hh"
#include "X_Train.hh"
#include "X_Weight.hh"



X_SpaceTimeNode :: X_SpaceTimeNode
( X_SpaceTimeNode const & x , bool _sw )
  : RS_Object ( x ) ,
    _dep ( x . _dep ) ,
    _t_ ( x . _t_ ) ,
    _cd_ ( x . _cd_ ) ,
    _is_trn ( _sw ) ,
    _trn ( x . _trn ) ,
    _plat ( x . _plat ) ,
    _weight ( 0 )
{
  if ( x . _weight )
  {
    _weight = x . _weight -> MyClone () ;
  }
  setName () ;
}



X_SpaceTimeNode :: X_SpaceTimeNode
( X_SpaceTimeNode const & x )
  : RS_Object ( x ) ,
    _dep ( x . _dep ) ,
    _t_ ( x . _t_ ) ,
    _cd_ ( x . _cd_ ) ,
    _is_trn ( x . _is_trn ) ,
    _trn ( x . _trn ) ,
    _plat ( x . _plat ) ,
    _weight ( 0 )
{
  if ( x . _weight )
  {
    _weight = x . _weight -> MyClone () ;
  }
}



X_SpaceTimeNode &
X_SpaceTimeNode :: operator=
( X_SpaceTimeNode const & x )
{
  if ( & x == this )
  {
    return * this ;
  }
  RS_Object :: operator= ( x ) ;
  _dep = x . _dep ;
  _t_ = x . _t_ ;
  _cd_ = x . _cd_ ;
  _is_trn = x . _is_trn ;
  _trn = x . _trn ;
  _plat = x . _plat ;
  if ( _weight )
  {
    delete _weight ;
  }
  if ( x . _weight )
  {
    _weight = x . _weight -> MyClone () ;
  }
  else
  {
    _weight = x . _weight ;
  }
  return * this ;
}





X_SpaceTimeNode :: ~X_SpaceTimeNode
()
{
  delete _weight ;
}






void
X_SpaceTimeNode :: setName
()
{
  string _ret_val = "NOPLAT" ;
  if ( _plat )
  {
    _ret_val = _plat -> getCombinationName () ;
  }
  if ( _trn )
  {
    if ( _dep )
    {
      _ret_val += "_DP_" ;
    }
    else
    {
      _ret_val += "_AR_" ;
    }
    _ret_val += _trn -> getName () ;
  }
  else
  {
    if ( _dep )
    {
      _ret_val += "_EXIT" ;
    }
    else
    {
      _ret_val += "_PASSENGER" ;
    }
  }
  if ( _is_trn )
  {
    _ret_val += "_T" ;
  }
  RS_Object :: setName ( _ret_val ) ;
}
