// -- This may look like C code, but it's really -*- C++ -*-



#ifndef __X_TheWorld_HH
#define __X_TheWorld_HH

#include "RS_FHeap.hh"
#define RS_DIJKSTRA_PRINT
#include "RS_Dijkstra.hh"
#include "X_Weight.hh"
#include "RS_Object.hh"
#include "X_SpaceTimeNode.hh"
#include "X_Station.hh"
#include "X_TrainType.hh"
#include "X_Train.hh"
#include "X_SpaceTimeBranch.hh"
#include "X_Depot.hh"
#include "X_TrainSet.hh"
#include "X_ScheduleSet.hh"
#include "X_PassengerActivity.hh"
#include <cstdlib>
#include <iostream>
#include <sstream>
#include <vector>
#include <string>
#include <map>
#include <unistd.h>

using std :: cout ;
using std :: cerr ;
using std :: endl ;
using std :: ostream ;
using std :: ostringstream ;
using std :: string ;
using std :: sort ;
using std :: map ;




// -----
// "The World".
// -----
class X_TheWorld
  : public virtual RS_Object
{
  // -----
  // Object containers for use with XML reader
  // -----
  X_Station_Container xs_c ;
  X_TrainType_Container xttyp_c ;
  X_Depot_Container xdpt_c ;
  X_ScheduleSet_Container xschs_c ;
  X_PassengerActivity_Container xpact_c ;

  // -----
  // Variables containing current path
  // -----
  string current_directory ;
  string current_drive ;
  bool is_backslash ;

public :

  // -----
  // Constructor.
  // Arguments: main function "argc" & "argv" and current working directory.
  // -----
  X_TheWorld ( int , char * * , char * ) ;

  // -----
  // Prepare SpaceTimeNode before evaluation.
  // -----
  void prepareSpaceTimeNodes () ;

  // -----
  // Solve "regular schedule".
  // -----
  void prepareSpaceTimeBranches () ;

private :

  void printUsage () ;

} ;




#endif /* ! __X_TheWorld_HH */
