// -*- C++ -*-

#include <stdexcept>
#include <typeinfo>
#include <iostream>
#include "X_Weight.hh"


using std :: cerr ;
using std :: endl ;




ostream &
operator<<
( ostream & out ,
  X_Weight_Base const & x )
{
  return x . writeOut ( out ) ;
}




bool
operator<
( X_Weight_Base const & x ,
  X_Weight_Base const & y )
{
  return x . isLessThan ( y ) ;
}




bool
Sujic_Weight :: isLessThan
( X_Weight_Base const & x )
  const
{
  try
  {
    Sujic_Weight const & y = dynamic_cast < Sujic_Weight const & > ( x ) ;
    if ( _time < y . _time )
    {
      return true ;
    }
    else if ( _time == y . _time )
    {
      if ( _transfers < y . _transfers )
      {
        return true ;
      }
      else if ( _transfers == y . _transfers )
      {
        if ( _time_walk < y . _time_walk )
        {
          return true ;
        }
        else if ( _time_walk == y . _time_walk )
        {
          if ( _time_wait < y . _time_wait )
          {
            return true ;
          }
          else
          {
            return false ;
          }
        }
        else
        {
          return false ;
        }
      }
      else
      {
        return false ;
      }
    }
    else
    {
      return false ;
    }
  }
  catch ( std :: bad_cast & bc )
  {
    cerr << "Error: in Sujic_Weight::isLessThan(): " << bc . what ()
         << endl ;
    exit ( 1 ) ;
  }
}


bool
operator==
( X_Weight_Base const & x ,
  X_Weight_Base const & y )
{
  return x . isEqualTo ( y ) ;
}



bool
Sujic_Weight :: isEqualTo
( X_Weight_Base const & x )
  const
{
  try
  {
    Sujic_Weight const & y = dynamic_cast < Sujic_Weight const & > ( x ) ;
    return _time == y . _time && _transfers == y . _transfers
      && _time_walk == y . _time_walk && _time_wait == y . _time_wait ;
  }
  catch ( std :: bad_cast & bc )
  {
    cerr << "Error: in Sujic_Weight::isEqualTo(): " << bc . what ()
         << endl ;
    exit ( 1 ) ;
  }
}



X_Weight_Base &
X_Weight_Base :: operator+=
( X_Weight_Base const & x )
{
  addWeight ( x ) ;
  return * this ;
}



void
Sujic_Weight :: addWeight
( X_Weight_Base const & y )
{
  try
  {
    Sujic_Weight const & x = dynamic_cast < Sujic_Weight const & > ( y ) ;
    _time += x . _time ;
    _transfers += x . _transfers ;
    _time_walk += x . _time_walk ;
    _time_wait += x . _time_wait ;
  }
  catch ( std :: bad_cast & bc )
  {
    cerr << "Error: in Sujic_Weight::addWeight(): " << bc . what ()
         << endl ;
    exit ( 1 ) ;
  }
}



X_Weight_Base &
X_Weight_Base :: operator-=
( X_Weight_Base const & x )
{
  subtractWeight ( x ) ;
  return * this ;
}



void
Sujic_Weight :: subtractWeight
( X_Weight_Base const & y )
{
  try
  {
    Sujic_Weight const & x = dynamic_cast < Sujic_Weight const & > ( y ) ;
    _time -= x . _time ;
    _transfers -= x . _transfers ;
    _time_walk -= x . _time_walk ;
    _time_wait -= x . _time_wait ;
  }
  catch ( std :: bad_cast & bc )
  {
    cerr << "Error: in Sujic_Weight::subtractWeight(): " << bc . what ()
         << endl ;
    exit ( 1 ) ;
  }
}
